<?php
/**
 * This file implements the ShareThis plugin.
 *
 * For the most recent and complete Plugin API documentation
 * see {@link Plugin} in ../evocore/_plugin.class.php.
 *
 * @package plugins
 *
 * {@internal Below is a list of authors who have contributed to design/coding of this file: }}
 * @author lnieves: Larry Nieves - {@link http://www.315-web.com/}
 *
 * @version $Id: _sharethis.plugin.php,v 0.1 2008/06/27 12:40:08 lnieves Exp $
 */
if( !defined('EVO_MAIN_INIT') ) die( 'Please, do not access this page directly.' );


/**
 * Blogalaxia_Tags Plugin
 *
 * This plugin responds to virtually all possible plugin events :P
 *
 * @package plugins
 */
class sharethis_plugin extends Plugin
{
	/**
	 * Variables below MUST be overriden by plugin implementations,
	 * either in the subclass declaration or in the subclass constructor.
	 */
	var $name = 'ShareThis';
	var $code = 'b2ShareThis';
	var $priority = 99;
	var $version = '0.1';
	var $group = 'rendering';
	var $author = 'Larry Nieves';
	var $help_url = 'http://cronicaslinuxeras.com/extension-sharethis-b2evolution';  // empty URL defaults to manual wiki


	/*
	 * These variables MAY be overriden.
	 */
	var $apply_rendering = 'opt-in';
	var $number_of_installs = 1;


	/**
	 * Init
	 *
	 * This gets called after a plugin has been registered/instantiated.
	 */
	function PluginInit( & $params )
	{
		$this->short_desc = T_('ShareThis Plugin');
		$this->long_desc = T_('It adds a ShareThis box at the end of every post, which enable the user to send the Post to a variety of social websites');
	}

  function  GetDefaultSettings()
  {
    return array(
      'publisher' => array(
        'label' => T_( 'ShareThis publisher ID' ),
        'defaultvalue' => '',
        'type' => 'text',
        'size' => 36,
        'maxlength' => 36,
        'note' => T_( 'This is you publisher ID in the format &laquo;xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx&raquo;; which you can find in the code provided by ShareThis' ),
        'valid_pattern' => '#\w{8}-(\w{4}-){3}\w{12}#' ),
      'services' => array(
        'label' => T_('Comma &laquo;,&raquo; separated list of services (social/sharing sites)'),
        'defaultvalue' => 'reddit,digg,facebook,myspace,delicious,stumbleupon,technorati,google_bmarks,yahoo_bmarks,yahoo_myweb,windows_live,newsvine,meneame',
        'note' => T_( 'Leave empty to use the default list of 20 services' ),
        'size' => 100 ) ) ;
  }

  function BeforeEnable()
  {
    return true ;
  }
  /* Add needed Javacript to Head section */
  function SkinBeginHtmlHead( & $params )
  {
    $pub = $this->Settings->get( 'publisher' ) ;
    $services = $this->Settings->get( 'services' );

    $sharethis_url = "http://w.sharethis.com/widget/?tabs=web%2Cpost%2Cemail&amp;charset=utf-8&amp;services=" ;
    $sharethis_url .= urlencode( $services) ;
    $sharethis_url .= '&amp;style=default&amp;publisher=' . $pub ;
    if ( ! $this->is_ie_crap() ) {
      require_js( $sharethis_url );
      return true;
    }
    return false;
  }

	/* Define HTML Hook */
	function RenderItemAsHtml( & $params )
  {
    // pre_dump( $params['data'] );
    $this->insert_sharethis_block( $params ) ;
    return true ;
  }

  /* Dummy 
  function RenderItemAsHtml( & $params )
  {
    return false;
  }
   */

  /* Define XML Hook. Do nothing */
  function RenderItemAsXml ( & $params )
  {
    return true ;
  }

	function insert_sharethis_block( & $params )
	{
    global $app_version;
    $content = & $params['data'] ;
    $item = & $params['Item'] ;

    if ( $app_version < 2 ) {
      $item_type = $item->typ_ID ;
    } else {
      $item_type = $item->ptyp_ID ;
    }
    if ( $item_type != 1 ) /* don't do it for links */ return false ;

    $title = "'" . $item->dget( 'title', 'htmlattr' ) . "'" ;
    $url   = "'" . $item->get_permanent_url() . "'" ;

//    pre_dump( $params );
    if ( ! $this->is_ie_crap() ) {
      $content .=  "\n".'<div class="sharethis">
        <script type="text/javascript" language="javascript">
          SHARETHIS.addEntry( {
            title : '. $title .',
              url   : '. $url   .'}, 
            { button: true }
          ) ;
        </script></div>' . "\n" ;    
    }

    return ( true ) ;
  }

  function is_ie_crap() {
    $match = preg_match( '/MSIE [56]\.\d/', $_SERVER['HTTP_USER_AGENT'] );
    return ( $match );
  }


}

/****** CHANGELOG *****
 ****** END CHANGELOG *****/
/* vi: ts=2 sw=2 et nu nowrap
 */
?>
